var GJ;
if(!GJ){
	GJ = {};
}

GJ = {

	firstPageLink: "",
	nextPageLink: "",
	rootElement: document.documentElement,
	requestType: "GET",
	hasEnoughBalance: false,
	purchaseEnabled: true,
	noAppsLoaded: true,
	inSandboxMode: false, 
	ftuxDisplayed: false,
	
	initialize: function(){
		if(typeof(rewardPage) === "object"){
			if(rewardPage.setSandboxMode){
				rewardPage.setSandboxMode(GJ.inSandboxMode);	
			}
		}
	},

	getAppListData: function(){
		$("#spinner").show();

			GJ.requestType = "GET";
		
		if(GJ.nextPageLink !== ""){
			$.ajax({
				url: GJ.nextPageLink,
				type: GJ.requestType,
				cache: false,
				dataType: 'json',
				error: GJ.ajaxErrorHandler,
				success: GJ.ajaxSuccessHandler
			});
		}
	},
	
	ajaxSuccessHandler: function(data, status, xhr){
		GJ.nextPageLink = data.rewardsNextPageLink;
		GJ.loadAppList(data);
		$("#spinner").hide();
		if(typeof(rewardPage) === "object"){
			if(rewardPage.isFirstTimeRun() && GJ.ftuxDisplayed === false){
				GJ.displayFtux();
				GJ.ftuxDisplayed = true;
			}
		}
	},

	ajaxErrorHandler: function(xhr, status){
		$("#spinner").hide();
	},
	
	loadAppList: function(data){
		var imgString, rewardAmountString, titleString, descrString, appObj, rewards;
		if(data.rewards){
			rewards = data.rewards;	
			for(var i=0; i<rewards.length; i++){
				imgString = '<img src="' + rewards[i].thumbnail + '"/>';
				rewardAmountString = '<div class="coins">' + rewards[i].rewardAmount + '</div>';
				titleString = '<h2>' + rewards[i].title + '</h2>';
				descrString = '<p>' + rewards[i].description + '</p>';
				appObj = $('<div class="app"></div>');
				appObj.attr({
					'data-downloadUrl': rewards[i].downloadUrl,
					'data-packageName': rewards[i].packageName,
					'data-beaconUrl': rewards[i].rewardsInstallLink
				});
				appObj.html(imgString + rewardAmountString + titleString + descrString);
				$('#appRoot').append(appObj);
				appObj.bind("click",GJ.clickHandler);
			}
			GJ.noAppsLoaded = false;
		}
		else if(GJ.noAppsLoaded === true){
			GJ.displayNoAppsMsg();
		}
	},
	
	//if the ajax calls fails or if the returned app list is empty, display an error message
	displayNoAppsMsg: function(){
		$('#appsHdr').hide();
		$('#appsErr').show();
	},
	
	// checks whether user has scrolled to bottom of the page. 
	scrollHandler: function(){
		var isPageBottom = ((GJ.rootElement.scrollHeight - GJ.rootElement.clientHeight) === window.pageYOffset);
		if(isPageBottom && GJ.nextPageLink !== ""){
			GJ.getAppListData();
		}
		else if(GJ.nextPageLink === ""){
			$('#footer').show();
		}
	},
	
	// click handler for advertiser apps on the offer wall
	clickHandler: function(e){
		e.preventDefault();
		var eventTargetObj, thumbnailUrl, title, description, rewardAmount, downloadUrl, packageName, beaconUrl, beaconImg;
		
		thumbnailUrl = $(this).find('img').attr('src');
		title = $(this).find('h2').text();
		description = $(this).find('p').text();
		rewardAmount = parseInt($(this).find('div.coins').text());
		downloadUrl = $(this).attr('data-downloadUrl');
		packageName = $(this).attr('data-packageName');
		beaconUrl = $(this).attr('data-beaconUrl');
		beaconImg = $('<img/>');
		beaconImg.attr('src',beaconUrl);
		
		eventTargetObj = $(this);
		eventTargetObj.addClass("active");
		window.setTimeout(function(){
			eventTargetObj.removeClass("active");
			if(typeof(rewardPage) === "object"){
				if(rewardPage.isCapReached() === false){
					rewardPage.getReward(thumbnailUrl, title, description, rewardAmount, downloadUrl, packageName);
				}
				else{
					GJ.displayReachedCap();
				}
			}			
		},300);
	},
	
	// called by the SDK
	// enable the purchase button if the transaction fails
	enablePurchase: function(){
		GJ.purchaseEnabled = true;
		$("#purchBtn").removeClass("disabled").addClass("purch");
		$("#purchBtn").bind("click",GJ.purchaseBtnTapHandler);		
	},

	// disable the purchase button
	// button should be disabled to ensure it is pressed only once thereby avoiding multiple transactions
	disablePurchase: function(){
		GJ.purchaseEnabled = false;
		$("#purchBtn").removeClass("purch").addClass("disabled");
		$("#purchBtn").unbind("click",GJ.purchaseBtnTapHandler);
	},
	
	// called by the SDK
	// when purchase transation is successful, wait 1 sec and redirect to host app
	purchaseSuccessful: function(){
		window.setTimeout(function(){
			if(typeof(rewardPage) === "object"){
				rewardPage.dismiss();
			}
		},1000);
		
	},
	
	// callback for purchase button tap event
	purchaseBtnTapHandler: function(e){
		if(GJ.hasEnoughBalance === false){
			GJ.displayInadequateBalance();			
		}
		else{
			if(typeof(rewardPage) === "object"){
				rewardPage.purchase();
			}
			GJ.disablePurchase();
		}
	},
	
	// callback for cancel button tap event
	cancelEventHandler: function(e){
		if(typeof(rewardPage) === "object"){
			rewardPage.cancel();
		}
	},
	
	// callback for close button tap event. 
	// close an open pop-up.
	popUpCloseEventHandler: function(e){
		$("#body").removeClass("noScroll");
		$("#header").removeClass("noPosition");
		$("#rewards").removeClass("noMargin");
		$("#bgMask").hide();
		$("#popBalance").hide();
		$("#popFtux").hide();
		$("#popReachedCap").hide();
	},
	
	reload: function(){
		if(typeof(rewardPage) === "object"){
			$("#walletBal").text(rewardPage.getWalletBalance());
			$("#itemName").text(String(rewardPage.getItemName()));
		//	GJ.log(String(rewardPage.getItemName()));
			$("#itemDescr").text(String(rewardPage.getItemDescription()));
		//	GJ.log(String(rewardPage.getItemName()));
			$("#itemCost").text(rewardPage.getItemCost());
			
			GJ.hasEnoughBalance = rewardPage.hasEnoughBalance();
		}
	},
	
	// If the user doesn't have enough balance to purchase an item, tapping on
	// purchase button will display a popup with an appropriate message
	displayInadequateBalance: function(){
		$("#body").addClass("noScroll");
		$("#header").addClass("noPosition");
		$("#rewards").addClass("noMargin");
		$("#bgMask").show();
		$("#popBalance").show();
	},
	
	displayReachedCap: function(){
		$("#body").addClass("noScroll");
		$("#header").addClass("noPosition");
		$("#rewards").addClass("noMargin");
		$("#bgMask").show();
		$("#popReachedCap").show();
	},
	
	displayFtux: function(){
		$("#body").addClass("noScroll");
		$("#header").addClass("noPosition");
		$("#rewards").addClass("noMargin");
		$("#bgMask").show();
		$("#popFtux").show();
		
	},
	
	// javascript console for debugging in the webview.
	// Any GJ.log() calls should be removed before pushing to QA
	log: function(str){
		$("#console").append(str + "<br/>");
	}
};

$(document).ready(function(){
	//need to remove
	$("#header").removeClass("hidden");
	$("#rewards").removeClass("hidden");
	GJ.initialize();
	GJ.reload();
	$("#purchBtn").bind("click",GJ.purchaseBtnTapHandler);
	$("#bgMask, #noBalanceBtn, .closeBtn, .footer .button").bind("click",GJ.popUpCloseEventHandler);
	$("#cancelBtn").bind("click",GJ.cancelEventHandler);
	
});
$(document).bind("scroll",GJ.scrollHandler);